﻿using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Parsing;
using Syncfusion.Pdf.Security;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Security.Cryptography;
using System.Security.Cryptography.Pkcs;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApplication1
{
    class Program
    {
        public static string DataPathBase
        {
            get
            {

                return System.Environment.CurrentDirectory + @"\..\..\Data\";

            }
        }
        public static string DataPathOutput
        {
            get
            {
                if (!System.IO.Directory.Exists(System.Environment.CurrentDirectory + @"\..\..\Output\"))
                    System.IO.Directory.CreateDirectory(System.Environment.CurrentDirectory + @"\..\..\Output\");
                return System.Environment.CurrentDirectory + @"\..\..\Output\";
            }
        }
        static void Main(string[] args)
        {
            PdfLoadedDocument loadedDocument = new PdfLoadedDocument(DataPathBase+ @"Input.pdf");
            PdfLoadedPage page = loadedDocument.Pages[0] as PdfLoadedPage;
            //Create a new PDF signature instance.  
            PdfSignature signature = new PdfSignature(loadedDocument, page, null, "Sig1");

            //Set the signature bounds.  
            signature.Bounds = new RectangleF(0, 0, 200, 100);

            //Call the compute hash event.  
            signature.ComputeHash += Signature_ComputeHash;

            loadedDocument.Save(DataPathOutput+"Output.pdf");
            loadedDocument.Close(true);
            System.Diagnostics.Process.Start(System.IO.Path.Combine(DataPathOutput, "Output.pdf"));
        }

        private static void Signature_ComputeHash(object sender, PdfSignatureEventArgs ars)
        {
            //Get the document bytes. 
            byte[] documentBytes = ars.Data;
           
            X509Certificate2 certificate = new X509Certificate2(DataPathBase+"PDF.pfx", "syncfusion");

            //Include the signed data to PDF.  
            ars.SignedData = Sign(documentBytes, certificate);
        }
        public static byte[] Sign(byte[] data, X509Certificate2 certificate)
        {
            if (data == null)
                throw new ArgumentNullException("data");
            if (certificate == null)
                throw new ArgumentNullException("certificate");

            // setup the data to sign 
            ContentInfo content = new ContentInfo(data);
            SignedCms signedCms = new SignedCms(content, false);
            CmsSigner signer = new CmsSigner(certificate);
    
            // create the signature
            signedCms.ComputeSignature(signer);
  
            return signedCms.Encode();
        }
    }
}
